//primary_file: test_file_comments.c









































/**
 * @file    interlock.c
 * @author  foxBMS Team
 * @date    2020-02-24 (date of creation)
 * @updated 2022-05-30 (date of last update)
 * @version v1.2.3
 * @ingroup DRIVERS
 * @prefix  ILCK
 *
 * @brief   Driver for the interlock.
 * @details The interlock driver measures the relevant hardware signals from
 *          the interlock circuit. For details on available hardware signals
 *          please refer to the section on this module in the foxBMS
 *          documentation.
 *
 *          In reference to the names in the foxBMS schematic, this module uses
 *          the following names:
 *
 *          shorthand | meaning
 *          --------- | ---------
 *          IL        | interlock
 *          HS        | high-side
 *          LS        | low-side
 *          VS        | voltage sense
 *          CS        | current sense
 *
 */
