/**
 *
 * @copyright &copy; 2010 - 2024, Fraunhofer-Gesellschaft zur Foerderung der angewandten Forschung e.V.
 * All rights reserved.
 *
 * SPDX-License-Identifier: BSD-3-Clause
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 *
 * 3. Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * We kindly request you to use one or more of the following phrases to refer to
 * foxBMS in your hardware, software, documentation or advertising materials:
 *
 * - "This product uses parts of foxBMS&reg;"
 * - "This product includes parts of foxBMS&reg;"
 * - "This product is derived from foxBMS&reg;"
 *
 */

/**
 * @file    doxygen_tests.h
 * @author  foxBMS Team
 * @date    2019-06-02 (date of creation)
 * @updated 2024-08-08 (date of last update)
 * @version v1.7.0
 * @ingroup UNIT_TEST_IMPLEMENTATION
 * @prefix  DX
 *
 * @brief   Mainpage doxygen documentation
 * @details TODO
 */

#ifndef FOXBMS__DOXYGEN_TESTS_H_
#define FOXBMS__DOXYGEN_TESTS_H_

/**
 * @mainpage API Documentation of the foxBMS Unit Tests
 *
 * <h3>Unit Test Files</h3>
 * - @ref UNIT_TEST_IMPLEMENTATION
 *
 * @defgroup UNIT_TEST_IMPLEMENTATION   Unit Test Implementation
 *
 * - @ref BATTERY_CELL_CONFIGURATION
 * - @ref BATTERY_SYSTEM_CONFIGURATION
 * - @ref ALGORITHMS
 * - @ref ALGORITHMS_CONFIGURATION
 * - @ref APPLICATION
 * - @ref APPLICATION_CONFIGURATION
 * - @ref DRIVERS
 * - @ref DRIVERS_CONFIGURATION
 * - @ref ENGINE
 * - @ref ENGINE_CONFIGURATION
 * - @ref TASK_CONFIGURATION
 * - @ref MAIN
 * - @ref MAIN_CONFIGURATION
 * - @ref OS
 *
 * @defgroup BATTERY_CELL_CONFIGURATION     Battery cell configuration
 *
 * @defgroup BATTERY_SYSTEM_CONFIGURATION   Battery system configuration
 *
 * @defgroup ALGORITHMS                     Algorithms
 * @defgroup ALGORITHMS_CONFIGURATION       Algorithm configurations
 *
 * @defgroup APPLICATION                    Application
 * @defgroup APPLICATION_CONFIGURATION      Application configurations
 *
 * @defgroup DRIVERS                        Driver
 * @defgroup DRIVERS_CONFIGURATION          Driver configurations
 *
 * @defgroup ENGINE                         Engine
 * @defgroup ENGINE_CONFIGURATION           Engine configurations
 *
 * @defgroup TASK                           Task
 * @defgroup TASK_CONFIGURATION             Task configuration
 *
 * @defgroup MAIN                           Main
 * @defgroup MAIN_CONFIGURATION             Main configuration
 *
 * @defgroup OS                             Operating system
 *
 * @defgroup STATE_MACHINE                  State machines (dummy group)
 * @defgroup DOXYGEN                        Doxygen configuration (dummy group)
 *
 */

/*========== Includes =======================================================*/

/*========== Unit Testing Framework Directives ==============================*/

/*========== Macros and Definitions =========================================*/

/*========== Extern Constant and Variable Declarations ======================*/

/*========== Extern Function Prototypes =====================================*/

/*========== Externalized Static Functions Prototypes (Unit Test) ===========*/
#ifdef UNITY_UNIT_TEST
#endif

#endif /* FOXBMS__DOXYGEN_TESTS_H_ */
